org.apache.xpath.functions

## Class FuncExtFunction

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.functions.Function
    - - org.apache.xpath.functions.FuncExtFunction

- All Implemented Interfaces:
    java.io.Serializable, SourceLocator, ExpressionNode, XPathVisitable

      public class FuncExtFunction
      extends Function

  An object of this class represents an extension call expression. When the expression executes, it calls ExtensionsTable#extFunction, and then converts the result to the appropriate XObject.
  See Also:
    Serialized Form
  Usage:
    **For advanced use only**

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FuncExtFunction(java.lang.String namespace, java.lang.String extensionName, java.lang.Object methodKey)` Create a new FuncExtFunction based on the qualified name of the extension, and a unique method key.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `callArgVisitors(XPathVisitor visitor)` Call the visitors for the function arguments.
    `void` | `checkNumberArgs(int argNum)` Check that the number of arguments passed to this function is correct.
    `XObject` | `execute(XPathContext xctxt)` Execute the function.
    `void` | `exprSetParent(ExpressionNode n)` Set the parent node.
    `void` | `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
    `Expression` | `getArg(int n)` Return the nth argument passed to the extension function.
    `int` | `getArgCount()` Return the number of arguments that were passed into this extension function.
    `java.lang.String` | `getFunctionName()` Return the name of the extension function.
    `java.lang.Object` | `getMethodKey()` Return the method key of the extension function.
    `java.lang.String` | `getNamespace()` Return the namespace of the extension function.
    `void` | `setArg(Expression arg, int argNum)` Set an argument expression for a function.
    `java.lang.String` | `toString()` Return the name of the extesion function in string format

    - ### Methods inherited from class org.apache.xpath.functions.Function

      `callVisitors, deepEquals, postCompileStep`

    - ### Methods inherited from class org.apache.xpath.Expression

      `asIterator, asIteratorRaw, asNode, assertion, bool, canTraverseOutsideSubtree, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FuncExtFunction

          public FuncExtFunction(java.lang.String namespace,
                         java.lang.String extensionName,
                         java.lang.Object methodKey)

      Create a new FuncExtFunction based on the qualified name of the extension, and a unique method key.
      Parameters:
        `namespace` - The namespace for the extension function, which should not normally be null or empty.
        `extensionName` - The local name of the extension.
        `methodKey` - Unique method key, which is passed to ExtensionsTable#extFunction in order to allow caching of the method.

  - ### Method Detail

    - #### fixupVariables

          public void fixupVariables(java.util.Vector vars,
                            int globalsSize)

      This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
      Specified by:
        `fixupVariables` in class `Expression`
      Parameters:
        `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame). NEEDSDOC @param globalsSize

    - #### getNamespace

          public java.lang.String getNamespace()

      Return the namespace of the extension function.
      Returns:
        The namespace of the extension function.

    - #### getFunctionName

          public java.lang.String getFunctionName()

      Return the name of the extension function.
      Returns:
        The name of the extension function.

    - #### getMethodKey

          public java.lang.Object getMethodKey()

      Return the method key of the extension function.
      Returns:
        The method key of the extension function.

    - #### getArg

          public Expression getArg(int n)

      Return the nth argument passed to the extension function.
      Parameters:
        `n` - The argument number index.
      Returns:
        The Expression object at the given index.

    - #### getArgCount

          public int getArgCount()

      Return the number of arguments that were passed into this extension function.
      Returns:
        The number of arguments.

    - #### execute

          public XObject execute(XPathContext xctxt)
                          throws TransformerException

      Execute the function. The function must return a valid object.
      Overrides:
        `execute` in class `Function`
      Parameters:
        `xctxt` - The current execution context.
      Returns:
        A valid XObject.
      Throws:
        `TransformerException`

    - #### setArg

          public void setArg(Expression arg,
                    int argNum)
                      throws WrongNumberArgsException

      Set an argument expression for a function. This method is called by the XPath compiler.
      Overrides:
        `setArg` in class `Function`
      Parameters:
        `arg` - non-null expression that represents the argument.
        `argNum` - The argument number index.
      Throws:
        `WrongNumberArgsException` - If the argNum parameter is beyond what is specified for this function.

    - #### checkNumberArgs

          public void checkNumberArgs(int argNum)
                               throws WrongNumberArgsException

      Check that the number of arguments passed to this function is correct.
      Overrides:
        `checkNumberArgs` in class `Function`
      Parameters:
        `argNum` - The number of arguments that is being passed to the function.
      Throws:
        `WrongNumberArgsException`

    - #### callArgVisitors

          public void callArgVisitors(XPathVisitor visitor)

      Call the visitors for the function arguments.
      Overrides:
        `callArgVisitors` in class `Function`

    - #### exprSetParent

          public void exprSetParent(ExpressionNode n)

      Set the parent node. For an extension function, we also need to set the parent node for all argument expressions.
      Specified by:
        `exprSetParent` in interface `ExpressionNode`
      Overrides:
        `exprSetParent` in class `Expression`
      Parameters:
        `n` - The parent node

    - #### toString

          public java.lang.String toString()

      Return the name of the extesion function in string format
      Overrides:
        `toString` in class `java.lang.Object`

Copyright © 2014 Apache XML Project. All Rights Reserved.